.\" OpenChange Project Tools Man Pages
.\"
.\" This manpage is Copyright (C) 2007 Julien Kerihuel;
.\" This manpage is Copyright (C) 2008 Brad Hards
.\"
.\" Permission is granted to make and distribute verbatim copies of this
.\" manual provided the copyright notice and this permission notice are
.\" preserved on all copies.
.\"
.\" Permission is granted to copy and distribute modified versions of this
.\" manual under the conditions for verbatim copying, provided that the
.\" entire resulting derived work is distributed under the terms of a
.\" permission notice identical to this one.
.\" 
.\" Since the OpenChange and Samba4 libraries are constantly changing, this
.\" manual page may be incorrect or out-of-date.  The author(s) assume no
.\" responsibility for errors or omissions, or for damages resulting from
.\" the use of the information contained herein.  The author(s) may not
.\" have taken the same level of care in the production of this manual,
.\" which is licensed free of charge, as they might when working
.\" professionally.
.\" 
.\" Formatted or processed versions of this manual, if unaccompanied by
.\" the source, must acknowledge the copyright and authors of this work.
.\"
.\" Process this file with
.\" groff -man -Tascii openchangeclient.1
.\"
.TH OPENCHANGECLIENT 1 2008-11-24 "OpenChange libmapi 0.8" "OpenChange Users' Manual"

.SH NAME
openchangeclient \- MAPI command line messaging tool

.SH SYNOPSIS
.nf
openchangeclient [-?|--help] [--usage] [-f|--database=STRING] [--pf]
  [-p|--profile=STRING] [-P|--password=STRING] [-S|--sendmail] 
  [--sendappointment] [--sendcontact] [--sendtask] [--sendnote]
  [-F|--fetchmail] [-G|--storemail=STRING] [-i|--fetch-items=STRING]
  [--freebusy=STRING] [--force] [--delete=STRING] [-u|--update=STRING]
  [-m|--mailbox] [-D|--deletemail] [-A|--attachments=STRING]
  [-I|--html-inline=STRING] [-W|--html-file=STRING] [-t|--to=STRING]
  [-c|--cc=STRING] [-b|--bcc=STRING] [-s|--subject=STRING] [-B|--body=STRING]
  [--location=STRING] [--label=STRING] [--dtstart=STRING] [--dtend=STRING]
  [--busystatus=STRING] [--taskstatus=STRING]
  [--importance=STRING] [--email=STRING] [--fullname=STRING] [--cardname=STRING]
  [--color=STRING] [--notifications] [--folder=STRING] [--mkdir] [--rmdir]
  [--userlist] [--folder-name=STRING] [--folder-comment=STRING]
  [-d|--debuglevel=STRING] [--dump-data] [--private]
  [--ocpf-file=STRING] [--ocpf-dump=STRING] [--ocpf-syntax] [--ocpf-sender]
.fi


.SH DESCRIPTION
openchangeclient is a MAPI command line tool designed to facilitate
mail send, receive and delete operations using the MAPI protocol. It
also provides operations on tasks, contacts (address book) and calendar
operations.

.SH COMMANDS

.TP
.B --fetchmail
.TP
.B -F
Fetch Exchange user mails from the inbox and display general information from
the mails on the standard output.

.TP
.B --storemail=DIRECTORY
.TP
.B -G
Store mail attachments to the local filesystem in the specified directory. This
is the normal way to retrieve attachments.

.TP
.B --fetch-items=STRING
.TP
.B -i
Retrieve specific items from Exchange default folders. Possible value
for STRING are Mail, Appointment, Contact, Task, Note.

.TP
.B --mkdir
Create a folder within the mailbox or public folders store
hierarchy. This command requires that the --folder-name option
be used to specify the name of the folder to create.

.TP
.B --rmdir
Deletes a folder within the mailbox or public folders store
hierarchy. This option requires that the --folder-name option
be used to specify the name of the folder to delete.

.TP
.B --mailbox
.TP
.B -m
Display the user mailbox folder hierarchy with folder names, folder
comments, the folder type, number of unread items in the folder 
and total number of items in the folder.

.TP
.B --notifications
Monitor NEWMAIL notifications in the Inbox folder and display summary
on standard output.

.TP
.B --sendmail
.TP
.B -S
Send a mail to a user belonging to the Exchange organization. This
requires specifying one or more recipients (see the --to, --cc and
--bcc options), a subject (see the --subject option) and a body
(see the --body, --html-file and --html-inline options).

.TP
.B --sendappointment
Create an appointment in the default calendar folder.

.TP
.B --sendcontact
Create a contact in the default contact folder.

.TP
.B --sendtask
Create a task in the default task folder.

.TP
.B --sendnote
Create a note in the default notes folder.

.TP
.B --deletemail
.TP
.B -D
Delete a mail from the exchange user mailbox. This requires
use of the --subject option to specify the mail to be deleted. 

.TP
.B --userlist
Display the users listed in the address book.

.TP
.B --delete=STRING
Delete a specified item from the store by ID number.

.TP
.B --ocpf-dump=STRING
Download a message (specified by the argument, which must be
the folder ID and unique message ID for the message) as OCPF format.
The message will be saved to a file given by the message ID, followed
by a suffix of .ocpf

See the separate (HTML) documentation for libocpf for more information
on the OCPF format.

.TP
.B --ocpf-sender
Send a message given in OCPF format to the server. This requires
use of the
.B --ocpf-file
option to specify the file to load from.

See the separate (HTML) documentation for libocpf for more information
on the OCPF format.

.TP
.B --ocpf-syntax
Check the syntax of an OCPF file. This does not perform any network
operations. This requires use of the 
.B --ocpf-file
option to specify
the file to load from.

See the separate (HTML) documentation for libocpf for more information
on the OCPF format.

.SH OPTIONS

.TP
.B --database=DATABASE
.TP
.B -f
Set the MAPI profile database. If no database is specified, then openchangeclient tries to load the default one: 
.B $HOME/.openchange/profiles.ldb

.TP
.B --profile=PROFILE
.TP
.B -p
Set the profile to use. If a profile is not specified, and one of the 
profiles has been set as the default in the profile database 
(for example, using mapiprofile -S), then that default profile will be used.

.TP
.B --password
.TP
.B -P
Specify the password for the profile to be used. This can be omitted if the
password is stored in the profile.

.TP
.B --pf
Perform operations against the Public Folders store, rather than the normal
operations against a user's private folders.

.TP
.B --folder
Specify the folder name we want to work with want to open. This option
is mandatory for public folders, but can also be used to open specific
folders in the mailbox store.

.TP
.B --attachments="ATTACHMENT1;ATTACHMENT2"
.TP
.B -A
Set attachments to send when sending a mail. Attached filenames need
to be separated with
.B semi-colons
as specified in the description above. This is only meaningful with
.B --sendmail

.TP
.B --subject=STRING
.TP
.B -s
Specify the mail subject. If no subject is specified, the mail subject will be empty.
This is only meaningful with
.B --sendmail

.TP
.B --body=STRING
.TP
.B -B
Set the body of the mail to be the UTF8 text only content specified on the command
line. This is only meaningful with
.B --sendmail

.TP
.B --html-inline=STRING
.TP
.B -I
Set the body of the mail to be the HTML content specified on command line. This is
only meaningful with
.B --sendmail

.TP
.B --html-file=FILENAME
.TP
.B -W
Set the body of the mail to be the content of the specified file. This is only
meaningful with
.B --sendmail

.TP
.B --to="USERNAME1,USERNAME2"
.TP
.B -t
Specify
.B To
recipients for the mail. Usernames need to be separated with commas
as specified in the example above. This is only meaningful with
.B --sendmail

.TP
.B --cc="USERNAME1,USERNAME2"
.TP
.B -c
Specify
.B Cc
recipients for the mail. Usernames need to be separated with commas
as specified in the example above. This is only meaningful with
.B --sendmail

.TP
.B --bcc="USERNAME1,USERNAME2"
.TP
.B -b
Specify
.B Bcc
recipients for the mail. Usernames need to be separated with commas
as specified in the example above. This is only meaningful with
.B --sendmail

.TP
.B --location=STRING
Specify the appointment location. This is only meaningful with
.B --sendappointment

.TP
.B --dtstart=STRING
Specify the start date of an event. The following date format needs to be used:
.B "%Y-%m-%d %H:%M:%S"
e.g: 2007-06-01 14:59:00. This is only meaningful with
.B --sendappointment
and
.B --sendtask

.TP
.B --dtend=STRING
Specify either the end date or due date of an event. The following date
format needs to be used:
.B "%Y-%m-%d %H:%M:%S"
e.g: 2007-06-01 14:59:00
When no
.B dtend
parameter is specified, default value is set to
.B dtstart
This is only meaningful with
.B --sendappointment
and
.B --sendtask

.TP
.B --force
Add appointment to the calendar, even if it would overlap with
an existing appointment. This is only meaningful with
.B --sendappointment

.TP
.B --private
Mark the appointment as private event. This is only meaningful with
.B --sendappointment

.TP
.B --busystatus=STRING
Set the busy status of an appointment. Possible values are FREE,
TENTATIVE, BUSY or OUTOFOFFICE. This is only meaningful with
.B --sendappointment

.TP
.B --label=STRING
Set the type of appointment. Possible values are NONE, IMPORTANT,
BUSINESS, PERSONAL, VACATION, MUST_ATTEND, TRAVEL_REQUIRED,
NEEDS_PREPARATION, BIRTHDAY, ANNIVERSARY and PHONE_CALL.
This is only meaningful with
.B --sendappointment

.TP
.B --taskstatus=STRING
Set the status of a task. Possible values are NOTSTARTED, PROGRESS,
COMPLETED, WAITING, DEFERRED. This is only meaningful with
.B --sendtask

.TP
.B --fullname=STRING
Set the full name in a contact message. This is only meaningful with
.B --sendcontact

.TP
.B --cardname=STRING
Set the card name of a task or contact message. This is only meaningful with
.B --sendcontact
or
.B --sendtask

.TP
.B --email=STRING
Set the email address in a contact message. This is only meaningful with
.B --sendcontact

.TP
.B --importance=STRING
Set the relative importance of a task. Possible values are LOW, NORMAL
and HIGH. This is only meaningful with
.B --sendtask

.TP
.B --color=STRING
Set the color of the note. The default color is Yellow. Other options
are Blue, Green, Pink and White. This is only meaningful with
.B --sendnote

.TP
.B --folder-name=STRING
Set the folder name to create. This is only meaningful with 
.B --mkdir 
or 
.B --rmdir

.TP
.B --folder-comment=STRING
Set the folder comment. This is only meaningful with
.B --mkdir

.TP
.B --update=STRING
.TP
.B -u
Change (update) an existing item, rather than creating a new one. This
is only meaningful with
.B --sendtask
, 
.B --sendnote
,
.B --sendappointment
and
.B --sendcontact

.TP
.B --ocpf-file=STRING
Specify the file to load OCPF data from. This is only meaningful with
.B --ocpf-sender
and
.B --ocpf-syntax

.TP
.B --dump-data
Display raw format data associated with the operation. You normally only
need this when debugging.

.TP
.B --debug-level=LEVEL
Display debugging information at the specified level (or higher). Level
10 is a lot of debug information.


.SH EXAMPLES

.B Fetching emails:
.nf
openchangeclient --database=/tmp/profiles.ldb --profile=2000 --fetchmail
.fi

.B Fetch emails and store attachments:
.nf
openchangeclient --database=/tmp/profiles.ldb --profile=2000 --fetchmail --storemail=test
.fi

All attachments from any mails will be stored in the test
directory. If the specified directory does not exist, it will
automatically be created. Note that if the attachment name
is not unique amongst all emails, some attachments may be 
overwritten. 


.B Send a basic email:
.nf
openchangeclient --database=/tmp/profiles.ldb --profile=2000 
                 --to="Adm,jker" --cc=Paul --bcc=Bill 
                 --subject="It is working"
                 --body="This is a sample body" --sendmail
.fi

A mail with UTF8 (text only) content will be sent with the following recipients:

to = Administrator and jkerihuel

cc = Paul

bcc = Bill


.B Send an inline HTML email:
.nf
openchangeclient --database=/tmp/profiles.ldb --profile=2000
                 --to=Adm --subject="Inline HTML sample email"
                 --html-inline="<body bgcolor=yellow><h1>My first HTML email</h1></body>"
                 --sendmail
.fi

Administrator will receive a mail with HTML body - yellow background and a title.


.B Send a HTML mail using a file:
.nf
openchangeclient --database=/tmp/profiles.ldb --profile=2000
                 --to=Adm --subject="HTML file email"
                 --html-file=/tmp/myfile.html
                 --sendmail
.fi

The content of /tmp/myfile.html will be used to fill the HTML body. If
the HTML file exceed a fixed size (0x4000 bytes), then PR_HTML content
will be sent using MAPI streams.


.B Send email with attachments:
.nf
openchangeclient --database=/tmp/profiles.ldb --profile=2000
                 --to=Adm --subject="Attachments"
                 --attachments="/tmp/file1.jpg;/tmp/file2.jpg;tmp/file2.jpg"
                 --body="These are sample attachments"
                 --sendmail
.fi

The example above will send a UTF8 body mail to Administrator and
attach file1,jpg, file2.jpg and file3.jpg to the email.

.B Display the users in the address book
.nf
openchangeclient --userlist
.fi

.B Fetch calendar items:
.nf
openchangeclient --fetch-items=Appointment
.fi


.B Fetch contact items:
.nf
openchangeclient --fetch-items=Contact
.fi


.B Fetch task items:
.nf
openchangeclient --fetch-items=Task
.fi


.B Create appointment:
.nf
openchangeclient --sendappointment --dtstart="2007-06-01 22:00:00" \\
                 --dtend="2007-06-01 22:35:00"                     \\
                 --busystatus=FREE                                 \\
                 --location="Home"                                 \\
                 --subject="Check the Junk folder"
.fi


.B Create Task:
.nf
openchangeclient --sendtask --dtstart="2008-11-01 18:00:00"        \\
                 --cardname="openchangeclient" --importance=HIGH   \\
                 --taskstatus=COMPLETED --body="my new task"
.fi


.B Create contact:
.nf
openchangeclient --sendcontact --cardname="openchangeclient"       \\
                 --fullname="OpenChange Client 3rd"                \\
                 --email="openchangeclient@nonexistentdomain.com"  
.fi

.B Create folder:
.nf
openchangeclient --mkdir --folder-name="openchange"		   \\
		 --folder-comment="comment"
.fi

This example will create a generic folder named openchange under the
Inbox folder.

.B Delete folder:
.nf
openchangeclient --rmdir --folder-name="openchange"
.fi

This example will delete the generic folder named openchange under
Inbox folder.

.B List Mailbox hierarchy:
.nf
openchangeclient --mailbox
.fi

.SH AUTHOR
Julien Kerihuel <j.kerihuel at openchange dot org>
